<?xml version="1.0" encoding="UTF-8" ?>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<title>TextGridLab Core Plug-ins Overview</title>
</head>
<body>
<h1>TextGridLab's Core Plug-ins</h1>
<p>TextGridLab's plug-in structure mainly aims at providing a
stand-alone application, based on the Eclipse Rich Client Platform
framework. Additionally, it should be possible to use TextGridLab's
features inside a usual Eclipse installation, possibly with some quirks.
This is reflected in the plug-in structure.</p>
<h2>Guidelines</h2>
<p>Basically, one job, one plug-in.</p>


<h2>Central Plug-ins and their Jobs</h2>

<h3>Lab Core</h3>

<dl>
	<dt class="package">info.textgrid.lab.core.model</dt>
	<dd>Classes modelling the basic TextGridRep resources – objects
	(TextGridObject), projects (TextGridProject) and the like.</dd>

	<dt class="package">info.textgrid.lab.core.efs.tgcrud</dt>
	<dd>Implementation of the TextGridRep access. Generally
	interesting for clients who should use the stuff in <code>info.textgrid.lab.core.model</code>.</dd>

	<dt class="package">info.textgrid.lab.core.browserfix</dt>
	<dd>Small plugin responsible for fixing the browser problems.
	Client implementations who need a browser control please use
	TextGridLabBrowser.createBrowser(Composite).</dd>

	<dt class="package">info.textgrid.lab.core.swtutils</dt>
	<dd>Various utility implementations to deal with SWT and Eclipse
	specific stuff. Might be interesting for everyone, doesn't contain
	TextGrid specific stuff. Never introduce dependencies to other lab
	plugins here!</dd>

	<dt class="package">info.textgrid.utils</dt>
	<dd>Utility classes that don't contain TextGrid- or Lab-specific
	stuff.</dd>

	<dt class="package">info.textgrid.lab.core.application</dt>
	<dd>Contains the <a
		href="../javadoc/info/textgrid/lab/core/application/Application.html">Application</a>
	class that controls our lifecycle, but more interestringly <a
		href="../javadoc/info/textgrid/lab/core/application/package-summary.html">
	various advisor classes</a> that set up the main workbench window of the
	stand-alone application. The menus and toolbars are set up to be
	compatible with the Eclipse Workbench. This plugin also contains the
	product definition for deploying the Lab application.</dd>

	<dt class="package">info.textgrid.lab.ui.core</dt>
	<dd>Contains common user interface code (like the new dialog
	etc.). Here are the global menu items, perspectives, handlers and some
	utility classes that might be interesting for other plugins. There
	should be no tool specific code here – this plugin should not depend on
	other UI plug-ins.</dd>

	<dt class="package">info.textgrid.lab.core.metadataeditor</dt>
	<dd>The component for displaying and manipulating TextGridObjects'
	metadata.</dd>

</dl>

<h3>Infrastructure Frontends</h3>

<p>These plug-ins provide frontend code to the TextGridLab
infrastructure. You should use them whenever you want to access a
utility and the classes in the model aren't enough.</p>

<p>When you write infrastructure frontends, please separate user
interface and model / implementation, and please do not leak ADB or Axis
classes … (AXIOM is fine).</p>

<dl>
	<dt class="package">info.textgrid.lab.conf</dt>
	<dd>Access to the configuration server. Use this to retrieve the
	URIs to the other utilities (and services).</dd>

	<dt class="package">info.textgrid.lab.authn</dt>
	<dd>Access to the authentication functionality. You'll usually
	want to call <code>RBACSession.getInstance().getSID(boolean)</code> to
	retrieve the session ID used for authentication.</dd>

	<dt class="package">info.textgrid.lab.log</dt>
	<dd>TextGrid-wide logging facility. You can retrieve the log ID
	used by several utilities here, and the user can display the remote
	log. Do not confuse this with the eclipse logging facility used for
	logging client-side events (StatusManager etc.)</dd>

	<dt class="package">info.textgrid.lab.search</dt>
	<dd>Frontend to TG-search. Use these classes if you need a
	specific search that you visualize yourself.</dd>

	<dt class="package">info.textgrid.lab.search.ui</dt>
	<dd>The search user interface.</dd>

	<dt class="package">info.textgrid.lab.navigator</dt>
	<dd>The navigator UI to browse through TextGrid.</dd>

	<dt class="package">info.textgrid.lab.projectadmin</dt>
	<dd>User and project administration GUI. This is a UI for some of
	the stuff in info.textgrid.lab.core.model.</dd>
</dl>

<h3 id="#other-lab-tools">Other Lab Tools</h3>

<p>These are the frontends for various lab tools.</p>

<dl>
	<dt class="package">info.textgrid.lab.workflow</dt>
	<dd>The preliminary workflow editor. The plug-in <span
		class="package">info.textgrid.lab.workflow.external</span> contains
	some libraries the workflow editor uses.</dd>

	<dt class="package">info.textgrid.lab.templateeditor</dt>
	<dd>Project managers can use the template editor to define which
	metadata shall be defined for objects in their respective projects.</dd>

	<dt><span class="package">info.textgrid.lab.dictionarysearch</span></dt>
	<dd>Plugin to search the <a href="http://www.woerterbuchnetz.de/">Wörterbuchnetz</a>.
	Also contains the <q>Dictionary Results View</q> that displays
	dictionary entries for the word currently selected in the XML editor –
	you might find inspiration here.</dd>

	<dt class="package">info.textgrid.lab.dictionarysearchmask</dt>
	<dd>Plugin to manually search the <a href="http://www.woerterbuchnetz.de/">Wörterbuchnetz</a>.
	You can narrow the search down to a single dictionary or a group of dictionaries. You can also
	freely choose the desired dictionaries within the Wörterbuchnetz.
	You can define the type of search, limit the count of search results, that were shown at once 
	in the Dictionary Search Results View and decide, if only entries should be shown, 
	that were linked with other dictionaries.</dd>

	<dt><span class="package">info.textgrid.lab.lemmatizer.serviceclient</span>,
	<span class="package">info.textgrid.lab.lemmatizer.ui</span></dt>
	<dd>Frontend code for the lemmatizer.</dd>

</dl>

<h3 id="xml-editor">XML Editor</h3>

<p>The XML editor integrates the XML editor from the <a
	href="http://www.eclipse.org/webtools/">Eclipse Web Tools Platform</a>
with a WYSIWYM component based on <a href="http://vex.sf.net">Vex</a>
and functionality specific for TextGrid.</p>

<dl>

	<dt class="package">info.textgrid.lab.xmleditor.mpeditor</dt>
	<dd>This is the core plug-in, it contains the multipage editor as
	well as integration code and TextGrid specific implementation.</dd>

	<dt class="package">net.sf.vex.toolkit</dt>
	<dd>Contains all backend functionality for the WYSIWYM part,
	especially the data model (see <span class="package">net.sf.vex.dom.linked</span>)
	and the layout code (<span class="package">net.sf.vex.layout</span>).</dd>

	<dt class="package">net.sf.vex.editor</dt>
	<dd>Contains the EditorPart for Vex, i.e. the Eclipse interfacing
	part.</dd>

	<dt class="package">de.textgrid.efrontend.charbrowser</dt>
	<dd>A unicode character browser. TODO this code needs to be
	updated …</dd>
</dl>

<h3 id="text-image-links">Text Image Link Editor</h3>

<p>The Text Image Link Editor is a tool to link a digitized image
of, e.g., a manuscript with its transcription on the level of image
areas.</p>

<dl>
	<dt class="package">info.textgrid.lab.linkeditor.controller</dt>
	<dt class="package">info.textgrid.lab.linkeditor.model</dt>
	<dd>Controller and model for managing the links</dd>

	<dt class="package">info.textgrid.lab.linkeditor.mip</dt>
	<dt class="package">info.textgrid.lab.linkeditor.mip.component</dt>
	<dd>Contains the image view and associated functionality. Parts of
	this origin at the ArchWay projects EPT.</dd>

	<dt class="package">info.textgrid.lab.linkeditor.rch.ept.libraries</dt>
	<dd>Libraries used by the link editor.</dd>

	<dt class="package">info.textgrid.lab.linkeditor.rcp_linkeditor</dt>
	<dd>contains the text view that is currently used for the Text
	part of the links. In the future, we will probably use the XML editor
	for this.</dd>
</dl>

<h3>Various GUI and Help stuff</h3>

<dl>

	<dt class="package">info.textgrid.lab.help</dt>
	<dd>The end user documentation for TextGridLab (in English).</dd>

	<dt class="package">info.textgrid.lab.doc.baseline</dt>
	<dd>The documentation for the TextGrid Baseline Encoding. Do not
	edit here – this is generated from the LaTeX code elsewhere in the SVN.</dd>

	<dt class="package">info.textgrid.lab.doc.programmer</dt>
	<dd>The developers' documentation you are currently reading. This
	plugin contains script to generate the Lab javadoc (executed at compile
	time) and HTML pages with the guide text you're currently reading.</dd>

	<dt class="package">info.textgrid.lab.welcome</dt>
	<dd>The welcome screen, as well as some perspectives that should
	be factored out of here.</dd>

	<dt class="package">info.textgrid.lab.eyecandy</dt>
	<dd>Some icons etc.</dd>

	<dt class="package">info.textgrid.lab.feedback.ui</dt>
	<dd>The report-a-bug dialogue.</dd>

</dl>

<h3>Stubs and libraries</h3>

<p>The plugins</p>
<ul>
	<li class="package">info.textgrid.lab.core.projectfile.stubs</li>
	<li class="package">info.textgrid.lab.core.tgcrud.client.adb</li>
	<li class="package">info.textgrid.middleware.tgauth.rbacstubs</li>
</ul>
<p>contain various web service stubs used by other plugins.</p>
<p>The plugins</p>
<ul>
	<li class="package">org.apache.axis2.full</li>
</ul>
<p>contain libraries repackaged for use in TextGridLab.</p>

<p>Finally, we're deploying XULrunner 1.8 with TextGridLab for
various architectures:</p>
<ul>
	<li class="package">org.mozilla.xulrunner.carbon.macosx</li>
	<li class="package">org.mozilla.xulrunner.gtk.linux.x86</li>
	<li class="package">org.mozilla.xulrunner.win32.win32.x86</li>
</ul>

</body>
</html>
